<form [formGroup]="form" novalidate>
  <div id="body" class="container-fluid">
    <div class="row mx-n5">
      <div class="col">
        <h6>H6 Folders</h6>
        <div *ngIf="!isReviewer" class="form-row mb-1">
          <div class="form-group form-group-sm col-4">
            <button type="button" class="btn btn-sm btn-primary btn-block" (click)="addFolder()">
              Add Folder
            </button>
          </div>
        </div>
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Search H6 Folder</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="search">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-24">Use the form below to search a H6 folder.</label>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">Customer ID: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="customerId" />
                    <div *ngIf="searchCustId.invalid && (searchCustId.dirty || searchCustId.touched)">
                      <span *ngIf="searchCustId.errors.invalidH1" class="form-text text-danger">
                        Customer ID is not in correct format. Customer ID should contain 9 digits only.
                      </span>
                    </div>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">City: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="city" />
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">Customer Name: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="customerName" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">Country: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-select-box [dataSource]="countryList" formControlName="country"
                                   displayExpr="ctryNme" valueExpr="ctryCd"
                                   [searchEnabled]="true" [searchExpr]="['ctryNme']"
                                   searchMode="startswith">
                    </dx-select-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8">M5 #/CTN: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="m5Ctn" />
                  </div>
                </div>
              </div>
              <div class="form-row text-center mt-1">
                <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
                  <button type="button" class="btn btn-sm btn-primary btn-block" (click)="search()">
                    Search
                  </button>
                </div>
                <div class="form-group form-group-sm col-12 col-md-6 col-lg-4">
                  <button type="reset" class="btn btn-sm btn-secondary btn-block" (click)="reset()">
                    Clear
                  </button>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>
        <div class="form-row" *ngIf="isSearchSubmitted">
          <div class="form-group form-group-sm row col-24">
            <label class="col-24">
              {{ (h5FolderList != null && h5FolderList.length > 0) ? 'Select a folder to see its content.' : 'No folders were found!' }}
            </label>
          </div>
        </div>
        <div *ngIf="h5FolderList != null && h5FolderList.length > 0">
          <dx-data-grid #gridH5Folder id="gridH5Folder" [dataSource]="h5FolderList" keyExpr="h5FoldrId"
                        [showBorders]="true" [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                        [columnAutoWidth]="true" 
                        (onSelectionChanged)="onSearchSelectionChanged($event)"
                        (onRowRemoving)="onSearchRowRemoving($event)"
                        (onToolbarPreparing)="onSearchToolbarPreparing($event)">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
            <dxo-paging [pageSize]="10"></dxo-paging>
            <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxi-column type="buttons" caption="Edit" [visible]="!isReviewer" cellTemplate="editButton"></dxi-column>
            <dxi-column type="buttons" caption="View" cellTemplate="viewButton"></dxi-column>
            <dxi-column dataField="custId" caption="Customer Id" dataType="string"></dxi-column>
            <dxi-column dataField="custNme" caption="Customer" dataType="string"></dxi-column>
            <dxi-column dataField="custCtyNme" caption="City" dataType="string"></dxi-column>
            <dxi-column dataField="ctryCd" caption="Country" dataType="string">
              <dxo-lookup [dataSource]="countryList" valueExpr="ctryCd" displayExpr="ctryNme"></dxo-lookup>
            </dxi-column>
            <dxi-column dataField="creatByUserAdId" caption="Created By" dataType="string"></dxi-column>
            <dxi-column dataField="creatDt" caption="Created Date" dataType="string"
                        cellTemplate="localStartTime" [allowEditing]="false"></dxi-column>
            <div *dxTemplate="let cell of 'localStartTime'">
              <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
            </div>
            <div *dxTemplate="let data of 'editButton'">
              <a class="dx-link dx-icon-edit dx-link-icon" title="Edit" (click)="onSearchEditClick(data)"></a>
            </div>
            <div *dxTemplate="let data of 'viewButton'">
              <a class="dx-link dx-icon-more dx-link-icon" title="View" (click)="onSearchViewClick(data)"></a>
            </div>
            <div *dxTemplate="let data of 'removeTemplate'">
              <button class="btn btn-sm btn-primary" type="button"
                      [disabled]="!selectedH5Folder.length || isReviewer" (click)="deleteH5Folders()">
                Remove Selected Records
              </button>
            </div>
          </dx-data-grid>
        </div>
      </div>
    </div>
  </div>

  <div #modal class="modal fade" id="folderDetails" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-xl" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h6 class="modal-title">H6 Folder</h6>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <mat-accordion>
            <mat-expansion-panel [expanded]="true" class="mb-1">
              <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                <mat-panel-title><h6>General</h6></mat-panel-title>
              </mat-expansion-panel-header>
              <div formGroupName="add">
                <div class="form-row">
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger">Customer ID: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <input type="text" class="form-control form-control-sm" formControlName="customerId" />
                      <div *ngIf="customerId.invalid && (customerId.dirty || customerId.touched || isSubmitted)">
                        <span *ngIf="customerId.errors.required" class="form-text text-danger">
                          Customer ID is required
                        </span>
                        <span *ngIf="customerId.errors.invalidH1" class="form-text text-danger">
                          Customer ID is not in correct format. Customer ID should contain 9 digits only.
                        </span>
                      </div>
                    </div>
                  </div>
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger">City: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <input type="text" class="form-control form-control-sm" formControlName="city" />
                      <div *ngIf="city.invalid && (city.dirty || city.touched || isSubmitted)">
                        <span *ngIf="city.errors.required" class="form-text text-danger">
                          City is required
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-row">
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger">Customer Name: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <input type="text" class="form-control form-control-sm" formControlName="customerName" />
                      <div *ngIf="customerName.invalid && (customerName.dirty || customerName.touched || isSubmitted)">
                        <span *ngIf="customerName.errors.required" class="form-text text-danger">
                          Customer Name is required
                        </span>
                      </div>
                    </div>
                  </div>
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger">Country: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <dx-select-box [dataSource]="countryList" formControlName="country"
                                     displayExpr="ctryNme" valueExpr="ctryCd"
                                     [searchEnabled]="true" [searchExpr]="['ctryNme']"
                                     searchMode="startswith">
                      </dx-select-box>
                      <div *ngIf="country.invalid && (country.dirty || country.touched || isSubmitted)">
                        <span *ngIf="country.errors.required" class="form-text text-danger">
                          Country is required
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-row" *ngIf="id > 0 && orderList != null && orderList.length > 0">
                  <div class="form-group form-group-sm row col-24">
                    <label class="col-24">ASSOCIATIONS</label>
                    <dx-data-grid #gridOrder id="gridOrder" [dataSource]="orderList" keyExpr="ordR_ID"
                                  [showBorders]="true" [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                                  [columnAutoWidth]="true" (onRowRemoving)="onSearchRowRemoving($event)">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-paging [pageSize]="10"></dxo-paging>
                      <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                      <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                      <dxi-column dataField="ftn" caption="M5 #/CTN" dataType="string" cellTemplate="linkIdTemplate"></dxi-column>
                      <dxi-column dataField="fsA_PROD_TYPE_DES" caption="Product Type" dataType="string"></dxi-column>
                      <dxi-column dataField="ordR_TYPE_DES" caption="Order Type" dataType="string"></dxi-column>
                      <dxi-column dataField="suB_TYPE" caption="Order Sub Type" dataType="string"></dxi-column>
                      <dxi-column dataField="ordR_STUS" caption="Order Status" dataType="string"></dxi-column>
                      <dxi-column dataField="creaT_DT" caption="Create Date" dataType="date" cellTemplate="dateTimeTemplate"></dxi-column>
                      <dxi-column dataField="prnT_FTN" caption="Parent M5 #" dataType="string"></dxi-column>
                      <dxi-column dataField="wrK_GRP_STUS" caption="Workgroup Status" dataType="string"></dxi-column>

                      <div *dxTemplate="let row of 'linkIdTemplate'">
                        <a class="hyperlink" (click)="selectionChangedHandler(row.data)">{{ row.value }}</a>
                      </div>
                      <div *dxTemplate="let cell of 'dateTimeTemplate'">
                        <span class="d-block">{{ cell.text | date: 'MM/dd/yyyy' }}</span>
                      </div>

                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <mat-accordion>
                <mat-expansion-panel [expanded]="true" class="mb-1">
                  <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                    <mat-panel-title><h6>H6 Documents</h6></mat-panel-title>
                  </mat-expansion-panel-header>
                  <app-doc-entity-template [docList]="docList" [option]="option" [disabled]="isView"></app-doc-entity-template>
                </mat-expansion-panel>
              </mat-accordion>

              <div class="form-row text-center mt-1">
                <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8"
                     *ngIf="(id > 0 && !isView) || id == 0">
                  <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()">
                    Save
                  </button>
                </div>
                <div class="form-group form-group-sm col-12 col-md-6 col-lg-4">
                  <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
                    {{ ((id > 0 && !isView) || id == 0) ? 'Cancel' : 'Close' }}
                  </button>
                </div>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
        </div>
      </div>
    </div>
  </div>
</form>
